const arg = process.argv;
const main = require('./main');
const config = require('../package.json');
const logs = require('./plug-in/colorLog');
if (arg.length < 3) {
    main();
}
if(arg.length >2){
    // 字母转小写
    const fs = require('fs');
    const init = require('./init');
    const {path} = require('./plug-in/fk2Path');
    if(!fs.existsSync(path())){
        logs.close();
        logs.blue('Fk2 began to initialize...');
        setTimeout( async () => {
            await init();
            logs.g('Initialization is complete...');
            logs.close();
        }, 800);
        return
    }
    const comm = arg[2].toLowerCase();
    if(comm=='init'){
        init();
    }else if(comm=='pkg'){
        // 创建js ts 等文件包
        require('./pkg/pkg');
    }else if(comm=='work'||comm=='-d'){
        // 开发服务器
        require('./work/work');
    }else if(comm=='-v'||comm=='-V'||comm=='-version'||comm=='-Version'){
        console.log(config.version);
    }else if(comm=='run'||comm=='start'){
        // 开启fk2集群
        require('./run/cluster');
    }else if(comm=='kill'||comm=='-k'){
        if(!arg[3]){
            console.log('Command not found!')
        }else{
            require('./exit/exit');
        }
    }else if(comm=='list'||comm=='ls'){
        require('./list/list');
    }else if(comm=='set'){
        require('./set/set');
    }else if(comm=='add'){
        require('./add/add');
    }else{
        console.log('Command not found!')
    }
}