// 初始化fk2
const fs = require('fs');
const addJson = require('./plug-in/addJSON');
const logs = require('./plug-in/colorLog');
const rrid = require('rrid');
const { 
    run,
    work, 
    log, 
    start, 
    server,
    funct, 
    host, 
    conf, 
    pkg 
} = require('./plug-in/fk2Path');
module.exports = () => {
    return new Promise((resolve) => {
        if (!fs.existsSync(work)) {
            const key = rrid.md5(new Date().getTime().toString());
            const secret = rrid.key(128);
            const data = {
                "workHost": "127.0.0.1",
                "workOpen": "1",
                "workPort": 443,
                "runHttp": 80,
                "runHttps": 443,
                "runIp": ["127.0.0.1"]
            }
            // 检查工作目录 .fk2
            fs.mkdirSync(work);
            fs.mkdirSync(log);
            fs.mkdirSync(pkg);
            fs.mkdirSync(funct);
            addJson(run);
            addJson(start);
            addJson(conf, data);
            addJson(host, {});
            addJson(server, {
                key,
                secret,
                auth: false
            });
            console.log('\n');
            logs.g('Service auth code : '+rrid.md5(key+secret)+'\n');
            logs.close();
            resolve();
        }else{
            logs.close();
            logs.skyBlue('The initialization has been completed! \n');
            require('./auth');
            logs.close();
            resolve();
        }
    })
}