// fk2 pgk 主要功能:压缩代码
const fs = require('fs');
const path = require('path');
const logs = require('../plug-in/colorLog');
const addJSON = require('../plug-in/addJSON');
const readline = require('readline').createInterface({
    input: process.stdin,
    output: process.stdout
});
// 表示创建js ts， 同时检查目录下是否存在fk2 包
let pkg = null;
try { pkg = require(paths('./package.json')) } catch (e) { };
if (pkg) {
    // 存在包时检查是否package.json包
    if (pkg.fk2 && pkg.fk2 == 'pkg') {
        // 是fk2 pkg包 开启工作模式
        require('./work');
    } else {
        // 不是fk2 pkg包
        logs.r('Thi is not fk2 package!');
        quests(pkg);
    }
} else {
    fk2Pkg(pkg);
}
function fk2Pkg(pkg) {
    // 创建包和开发和工作目录
    if (!fs.existsSync(paths('/work'))) {
        fs.mkdirSync(paths('/work'));
    }
    if (!fs.existsSync(paths('/dev'))) {
        fs.mkdirSync(paths('/dev'));
    }
    const arr = process.cwd().split('\\');
    const name = arr[arr.length - 1];
    if (!pkg) {
        pkg = {
            name: 'fk2-pkg',
            version: '1.0.0',
            description: '',
            scripts: { test: 'echo "Error: no test specified" && exit 1' },
            keywords: [],
            author: '',
            license: 'ISC'
        }
    }
    pkg.name = name;
    pkg.fk2 = "pkg";
    pkg.main = "work/main.js";
    addJSON(paths('./package.json'), pkg);
    require('./work');
}
function quests(pkg) {
    logs.close();
    readline.question('Change to fk2 package ?  yes / no : ', (data) => {
        if (data == 'yes') {
            logs.close();
            fk2Pkg(pkg);
        } else if (data == 'no') {
            process.kill(0);
        } else {
            logs.r('Input error!');
            quests(pkg);
        }
    })
}
function paths(url) {
    return path.join(process.cwd(), url)
}

