const arr = [
    {
        name:'匹配单行注释正则表达式',
        reg:/(?:^|\n|\r)\s*\/\/.*(?:\r|\n|$)/g,
    },
    {
        name:'匹配多行注释正则表达式',
        reg:/(?:^|\n|\r)\s*\/\*[\s\S]*?\*\/\s*(?:\r|\n|$)/g,
    },
    {
        name:'替换 = 前后空格',
        reg:/(\s*=\s*)/g,
        data:'='
    },
    {
        name:'替换 ()=>{ 前后空格',
        reg:/(\s*\(\)=>\s*{)/g,
        data:'()=>{'
    },
    {
        name:'替换 { 后空格',
        reg:/({\s*)/g,
        data:'{'
    },
    {
        name:'替换}前空格',
        reg:/(\s*})/g,
        data:'}'
    },
    {
        name:'替换 [ 后空格',
        reg:/(\[\s*)/g,
        data:'['
    },
    {
        name:'替换]前空格',
        reg:/(\s*])/g,
        data:']'
    },
    {
        name:'替换;前后空格',
        reg:/(\s*;\s*)/g,
        data:';'
    },
    {
        name:'替换,前后空格',
        reg:/(\s*,\s*)/g,
        data:','
    },
    {
        name:'替换:前后空格',
        reg:/(\s*:\s*)/g,
        data:':'
    },
    {
        name:'替换?前后空格',
        reg:/(\s*\?\s*)/g,
        data:'?'
    },
    {
        name:'替换||前后空格',
        reg:/(\s*\|\|\s*)/g,
        data:'||'
    },
    {
        name:'替换) {空格',
        reg:/(\)\s*{)/g,
        data:'){'
    },
    {
        name:'替换)  {',
        reg:/(\)\s*{)/g,
        data:'){'
    },
     
    // 替换所有关键字符隔一个字符
    {
        name:'替换var  ',
        reg:/(\s+var\s+)/g,
        data:';var '
    },
    {
        name:'替换let ',
        reg:/(\s+let\s+)/g,
        data:';let '
    },
    {
        name:'替换const ',
        reg:/(\s+const\s+)/g,
        data:';const '
    },
    {
        name:'替换function ',
        reg:/(\s+function\s+)/g,
        data:';function '
    },
    {
        name:'替换if ',
        reg:/(\s+if\s+)/g,
        data:';if '
    },
    {
        name:'替换return ',
        reg:/(\s+return\s+)/g,
        data:';return '
    },
    {
        name:'替换try ',
        reg:/(\s+try\s+)/g,
        data:';try '
    },
    {
        name:'替换} else {',
        reg:/(}\s+else\s+{)/g,
        data:'}else{'
    },
    {
        name:'替换return;',
        reg:/(return;\s*)/g,
        data:'return '
    },
    {
        name:'换行',
        reg:/(\n)/g,
        data:';'
    },
    {
        name:' ; ',
        reg:/(\s*;\s*)/g,
        data:';'
    },
    {
        name:'else;if',
        reg:/(else;if)/g,
        data:'else if'
    },
]
module.exports = arr;