const arg = process.argv;
const cluster = require('cluster');
const logs = require('../plug-in/colorLog');
const {exist,mainFun,wkFun,onExit,watch} = require('./workType');
if (arg[2] == 'start') {
    var paths = exist();
    if(!paths) return 
}
if (cluster.isMaster || cluster.isPrimary) {
    /* 多少个cpu启动多少个子进程 */
    clusterMain();
    async function clusterMain() {
        const wk = require('./worker');// 封装wk循环
        const cpu = await mainFun(); //主进程函数
        if(!cpu) {
            // 终止开启子进程
            return
        }
        logs.g('Open clusters!');
        logs.close();
        for (let i = 0; i < cpu; i++) {
            // 时间间隔防止文件读取冲突
            setTimeout(() => {
                wk(cluster.fork());
            }, (i+1)*100);
        }
        watch(); //监听文件是否有重启动作
        /* 如果有线程退出了，我们重启一个 */
        cluster.on('exit', (obj) => {
            if(onExit(obj.process.pid)){
                wk(cluster.fork());
            }
        })
    }

} else {
    if (arg[2] == 'start') {
        new require(paths);
    } else {
        new require('./go');
    }
    wkFun(); // 工作进程函数
    /* 心跳回应 */
    process.on('message', (msg) => {
        msg === 'goto' && process.send('back');
    })
}