const fs = require('fs');
const path = require('path');
const http = require('http');
const https = require('https');
const express = require('express');
const app = express();
app.use(express.json()); //  application/json
app.disable('x-powered-by');//去除x-powered-by响应字段
// application/x-www-form-urlencoded
app.use(express.urlencoded({ extended: true })); 
const {conf} = require('../plug-in/fk2Path');
const confs = require(conf);
// 根据项目的路径导入生成的证书文件
const key = fs.readFileSync(path.join(__dirname,'../work/key/ssl.key')).toString()
const cert = fs.readFileSync(path.join(__dirname,'../work/key/ssl.pem')).toString()
const {decrypt} =require('../plug-in/key')
const checkIP = require('../plug-in/checkClientIp'); //检查ip白名单
app.all('*', (req, res) => {
    const {originalUrl} = req;
    if(originalUrl=='/restart'){
        const restart = require('../plug-in/restart');
        restart()
    }
    res.json({
        url:originalUrl
    })
})
http.createServer(app).listen(confs.runHttp?confs.runHttp:80)
https.createServer({key:decrypt(key),cert:decrypt(cert)}, app).listen(confs.runHttps?confs.runHttps:443);
