const max = 10;
const arg = process.argv;
const os = require('os');
const fs = require('fs');
var cpu = os.cpus().length;
const path = require('path');
const {md5} = require('rrid');
const logs = require('../plug-in/colorLog');
const {kill,check} = require('../plug-in/psNode');
const {run,start} = require('../plug-in/fk2Path');
const addJson = require('../plug-in/addJSON');
const readJson = require('../plug-in/readJSON');
const goLogs = require('../plug-in/goLogs');// 写启动日志
module.exports = {
    async mainFun(){
        // 主进程函数
        logs.g('Service is starting , please later ...');
        logs.close();
        if (arg[2] == 'start') {
            // fk2 start ...
            cpu = cpus(arg[4]);
            var data = readJson(start);
            if(!data) return 0;
            const id = md5(process.cwd()+arg[3]);
            if(data[id]&&data[id].ppid){
                const res = await check(data[id].ppid)
                if(res) {
                    console.log(res);
                    logs.r(arg[3]+ ' already open!')
                    return 0;
                }
            }
            data[id] = {
                cwd: process.cwd(),
                script: arg[3],
                pids:{},
                ppid: process.pid,
                time: new Date().getTime(),
                close:"0"
            }
            addJson(start,data);
            goLogs(1);
        } else {
            require('../auth');// json验证集群是否被绑定
            cpu = cpus(arg[3]);
            var data = readJson(run);
            if(!data) return 0;
            if(data&&data.ppid){
                const res = await check(data.ppid)
                if(res) {
                    console.log(res);
                    logs.r('Fk2 already open!')
                    return 0;
                }
            }
            data.pids = {};
            data.ppid = process.pid;
            data.time = new Date().getTime();
            data.close = "0";
            addJson(run,data);
            goLogs(1);
        }
        return cpu;
    },
    wkFun(){
        // 工作进程函数
        if(arg[2]== 'start'){
            var data = readJson(start);
            if(!data) return 0;
            const id = md5(process.cwd()+arg[3]);
            data[id].pids[process.pid] = "1";
            addJson(start,data);
            goLogs();
        }else{
            var data = readJson(run);
            if(!data) return 0;
            data.pids[process.pid] = "1";
            addJson(run,data);
            goLogs();
        }
    },
    onExit(pid){
        // 监听退出判断是否重启 0不重启
        if(arg[2]=='start'){
            var data = readJson(start);
            if(!data) return false;
            const id = md5(process.cwd()+arg[3]);
            const res = data[id].pids[pid];
            delete data[id].pids[pid];
            addJson(start,data);
            if(res > 0){
                return true;
            }else{
                return false;
            }
        }else{
            var data = readJson(run);
            if(!data) return false;
            const res = data.pids[pid];
            delete data.pids[pid];
            addJson(run,data);
            if(res > 0){
                return true;
            }else{
                return false;
            }
        }
    },
    exist(){
        // 为省略.js和.ts 后缀
        var paths = path.join(process.cwd(), arg[3]);
        if (!fs.existsSync(paths)) {
            // 简写.js和.ts
            if (fs.existsSync(paths + '.js')) {
                paths = paths + '.js';
            } else if (fs.existsSync(paths + '.ts')) {
                paths = paths + '.ts';
            } else {
                logs.r('Can not find ' + arg[3] + ' script!');
                logs.r('error path: ' + paths);
                logs.close();
                paths = false;
            }
        }
        return paths;
    },
    watch(){
        // 监听文件是否有重启动作
        if(arg[2]=='start'){
            fs.watchFile(start, async(cur, prv) => {
                // 监听文件
                if (cur.mtime !== prv.mtime) {
                    var data = readJson(start);
                    if(!data) return false;
                    const id = md5(process.cwd()+arg[3]);
                    if(data[id].close=="1"){
                        data[id].close="0";
                        addJson(start,data);
                        await kill(data[id].ppid);
                    }
                    restart(data[id].pids);
                }
            })
        }else{
            fs.watchFile(run, async(cur, prv) => {
                // 监听文件
                if (cur.mtime !== prv.mtime) {
                    var data = readJson(run);
                    if(!data) return false;
                    if(data.close=="1"){
                        data.close="0";
                        addJson(run,data);
                        await kill(data.ppid);
                    }
                    restart(data.pids);
                }
            })
        }
    }    
}
async function restart(pids) {
    // 退出进程 重启或关闭
    if(Object.keys(pids).length>0){
        for (const key in pids) {
            if(pids[key]==0||pids[key]==3){
                //重启状态为0或3的进程 
                await kill(key);
            }
        }
        return pids
    }else{
        return false
    }
}

function cpus(d) {
    // 判断并且输出单例数
    if(!d&&d!=0){
        cpu = 1;
    }else if (d && d == 'max') {
        cpu = cpu;
    } else if (d && d > 0&&d<cpu+max+1) {
        cpu = d;
    } else {
        logs.r('Open the failure!');
        logs.close();
        logs.r('The number of processes cannot be greater than '+(cpu+max));
        logs.close();
        cpu = 0;
    }
    return cpu;
}